Imports System.IO
Public Class frmScanner
    Dim Ret As Long, PictureFile As String
    Private Declare Function TWAIN_AcquireToFilename Lib "TWAIN32d.DLL" (ByVal hwndApp As Integer, ByVal bmpFileName As String) As Short
    Private Declare Function TWAIN_IsAvailable Lib "TWAIN32d.DLL" () As Integer
    Private Declare Function TWAIN_SelectImageSource Lib "TWAIN32d.DLL" (ByVal hwndApp As Integer) As Integer
    Private Sub frmScanner_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        On Error Resume Next
        Me.StartPosition = FormStartPosition.CenterScreen
        If Not IO.File.Exists("C:\WINDOWS\system32\TWAIN32d.dll") Then IO.File.Copy(Application.StartupPath & "\TWAIN32d.dll", "C:\WINDOWS\system32\TWAIN32d.dll")
        Me.PictureBox.SizeMode = PictureBoxSizeMode.StretchImage
    End Sub
    Private Sub ScannerButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ScannerButton.Click
        On Error Resume Next
        If Me.PathTextbox.Text.Length = 0 Then
            MessageBox.Show("    ", " ", MessageBoxButtons.OK, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign)
            Me.PathTextbox.Focus()
            Exit Sub
        Else
            TWAIN_SelectImageSource(Me.Handle.ToInt32)
            Ret = TWAIN_AcquireToFilename(Me.Handle.ToInt32, PictureFile)
            If Ret = 0 Then
                Me.PathTextbox.Clear()
                Me.PathTextbox.Text = PictureFile
                Me.PictureBox.Image = Image.FromFile(PictureFile)
                Me.WindowState = FormWindowState.Minimized
                Me.WindowState = FormWindowState.Normal
            Else
                Kill(PictureFile)
                MessageBox.Show("   ", "", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign)
            End If
        End If
    End Sub
    Private Sub PathButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PathButton.Click
        On Error Resume Next
        SaveDialog.Title = " "
        SaveDialog.Filter = "Bitmap file (*.bmp)|*.bmp|TIFF file (*.tif)|*.tif|JPEG file (*.jpg)|*.jpg|PNG file (*.png)|*.png|GIF file (*.gif)|*.gif|All files (*.*)|*.*"
        SaveDialog.FilterIndex = 1
        If SaveDialog.ShowDialog() <> System.Windows.Forms.DialogResult.OK Then
            Exit Sub
        End If
        If Len(SaveDialog.FileName) > 0 Then
            PictureFile = SaveDialog.FileName
            Me.PathTextbox.Clear()
            Me.PathTextbox.Text = PictureFile
        End If
    End Sub
End Class
